;  getfdt.asm  - Rod L Renner, FEMA/SL-AC, Aug 88
;
;  called from QB3.0
;
;  call getfdt(F$,yr%,mo%,day%,hour%,min%,sec%)
;                          searches for ASCIIZ file F$
;                          using Find First Matching File (4E),
;                          returns file's date and time values
;                          if found, else yr%=-1 if not found
;
code    segment byte public 'code'
        assume cs:code
        public getfdt
getfdt  proc far
        push bp
        mov bp,sp
        mov bx,[bp]+18
        mov dx,[bx]+2      ; get pointer to ASCIIZ string
        mov ah,2fh
        int 21h            ; get DTA address
        mov cx,7
        mov ah,4eh
        int 21h            ; Find First Matching File
        mov ax,-1
        jc  pass
        mov ax,es:[bx+24]   ; found - ax = date field
        mov dx,es:[bx+22]   ; dx = time field
        mov cx,11111b
        and cx,dx
        shl cx,1            ; cx = sec (0-59)
        mov bx,[bp]+6
        mov [bx],cx
        mov cl,5
        shr dx,cl
        mov cx,111111b
        and cx,dx           ; cx = min (0-59)
        mov bx,[bp]+8
        mov [bx],cx
        mov cl,6
        shr dx,cl           ; dx = hour  (0-23)
        mov bx,[bp]+10
        mov [bx],dx
        mov cx,11111b
        and cx,ax           ; cx = day (1-31)
        mov bx,[bp]+12
        mov [bx],cx
        mov cl,5
        shr ax,cl
        mov cx,1111b
        and cx,ax           ; cx = month (1-12)
        mov bx,[bp]+14
        mov [bx],cx
        mov cl,4
        shr ax,cl
        add ax,1980         ; ax = year (1980-2099)
pass:   mov bx,[bp]+16
        mov [bx],ax         ; save value of ax (yy or -1)
        pop bp
        ret 14
getfdt  endp
code    ends
        end
